﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

lang_msg = es.import_addon("soccer_mod_2011")

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "modules/cap/messages_cap.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "modules/cap/popups_cap.ini")

gks = []
defs = []
mids = []
wings = []

# ******************** Load ********************
def load():
	load_variables()

	es.set("sm_cap_round_ended", 0)
	es.set("sm_cap_fight_weapon", "knife")
	es.set("sm_cap_fight_health", 100)
	es.set("sm_cap_fight_speed", 1.0)
	es.set("sm_cap_fight_jump", 0)

	create_popup()

	es.addons.registerSayFilter(filter)

# ******************** Create popup ********************
def create_popup():
	popup = popuplib.create("sm_popup_admin_cap")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")
	popup.addline("->1. %s" % (popup_text("spectator")))
	popup.addline("->2. %s" % (popup_text("random_player")))
	popup.addline("->3. %s" % (popup_text("start")))
	popup.addline("->4. %s: %s" % (popup_text("weapon"), es.ServerVar("sm_cap_fight_weapon")))
	popup.addline("->5. %s: %s" % (popup_text("health"), es.ServerVar("sm_cap_fight_health")))
	popup.addline("->6. %s: %s" % (popup_text("speed"), es.ServerVar("sm_cap_fight_speed")))
	popup.addline("->7. %s: %s" % (popup_text("jump"), es.ServerVar("sm_cap_fight_jump")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	for i in range(1, 8):
		popup.select(i, popup_choice)

	popup.submenu(8, "sm_popup_admin_cap")
	popup.submenu(9, "sm_popup_admin")

# ******************** Events ********************
def es_map_start(event_var):
	gamethread.cancelDelayed("sm_cap_fight")

	load_variables()

def player_spawn(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_cap_fight_started") == 1:
			player = playerlib.getPlayer(event_var["userid"])
			if player.team > 1:
				if es.ServerVar("sm_cap_fight_frozen") == 0:
					player.setHealth(es.ServerVar("sm_cap_fight_health"))
					player.setSpeed(es.ServerVar("sm_cap_fight_speed"))

					weapon = es.ServerVar("sm_cap_fight_weapon")
					if weapon != "knife":
						es.server.queuecmd("es_xgive %s weapon_%s" % (event_var["userid"], weapon))
				else:
					player.freeze(1)

def flashbang_detonate(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_cap_fight_started") == 1:
			if es.ServerVar("sm_cap_fight_frozen") == 0:
				if es.ServerVar("sm_cap_fight_weapon") == "flashbang":
					player = playerlib.getPlayer(event_var["userid"])
					if player.isdead == 0:
						if player.getFB() == 0:
							es.server.queuecmd("es_xgive %s weapon_flashbang" % (event_var["userid"]))

def hegrenade_detonate(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_cap_fight_started") == 1:
			if es.ServerVar("sm_cap_fight_frozen") == 0:
				if es.ServerVar("sm_cap_fight_weapon") == "hegrenade":
					player = playerlib.getPlayer(event_var["userid"])
					if player.isdead == 0:
						if player.getHE() == 0:
							es.server.queuecmd("es_xgive %s weapon_hegrenade" % (event_var["userid"]))

def smokegrenade_detonate(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_cap_fight_started") == 1:
			if es.ServerVar("sm_cap_fight_frozen") == 0:
				if es.ServerVar("sm_cap_fight_weapon") == "smokegrenade":
					player = playerlib.getPlayer(event_var["userid"])
					if player.isdead == 0:
						if player.getSG() == 0:
							es.server.queuecmd("es_xgive %s weapon_smokegrenade" % (event_var["userid"]))

def player_jump(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_cap_fight_started") == 1:
			if es.ServerVar("sm_cap_fight_frozen") == 0:
				if es.ServerVar("sm_cap_fight_jump") > 0:
					player = playerlib.getPlayer(event_var["userid"])
					player.push(es.ServerVar("sm_cap_fight_jump"), es.ServerVar("sm_cap_fight_jump"))

def player_death(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_cap_fight_started") == 1:
			if es.ServerVar("sm_cap_fight_frozen") == 0:
				es.set("sm_cap_winner_userid", event_var["attacker"])
				es.set("sm_cap_loser_userid", event_var["userid"])

def round_start(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		es.set("sm_cap_round_ended", 0)

		if es.ServerVar("sm_cap_fight_started") == 1:
			gamethread.cancelDelayed("sm_cap_fight")

			load_variables()

			for ply in playerlib.getPlayerList("#alive"):
				if es.ServerVar("sm_health_god_mode_on") == 1:
					ply.godmode(1)

				if es.ServerVar("sm_module_health_on") == 1:
					ply.setHealth(es.ServerVar("sm_health_amount"))

				ply.setSpeed(1)

				es.server.queuecmd("es_xgive %s player_weaponstrip" % (ply))
				es.server.queuecmd("es_xfire %s player_weaponstrip strip" % (ply))

				es.server.queuecmd("es_xgive %s weapon_knife" % (ply))

def round_end(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		es.set("sm_cap_round_ended", 1)

		if es.ServerVar("sm_cap_fight_started") == 1:
			gamethread.cancelDelayed("sm_cap_fight")

			load_variables()

			es.set("sm_cap_winner_pick", 1)
			es.set("sm_cap_winner_number", 5)
			es.set("sm_cap_loser_number", 5)

			if len(playerlib.getPlayerList("#human,#spec")) > 0:
				tokens = {}
				tokens["command"] = es.ServerVar("sm_cap_command_pick")

				userid = es.ServerVar("sm_cap_winner_userid")
				if userid > 1:
					send_pick_menu(userid)

					player = playerlib.getPlayer(userid)
					es.tell(userid, "#green", messages_text("pick_command", tokens, player.get("lang")))

				userid = es.ServerVar("sm_cap_loser_userid")
				if userid > 1:
					player = playerlib.getPlayer(userid)
					es.tell(userid, "#green", messages_text("pick_command", tokens, player.get("lang")))

# ******************** Commands ********************
def cmd_pick():
	userid = int(es.getcmduserid())
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		winnerid = int(es.ServerVar("sm_cap_winner_userid"))
		loserid = int(es.ServerVar("sm_cap_loser_userid"))
		pick = int(es.ServerVar("sm_cap_winner_pick"))

		if winnerid == userid:
			if pick == 1:
				if int(es.ServerVar("sm_cap_winner_number")) > 0:
					send_pick_menu(winnerid)
				else:
					es.tell(userid, "#green", messages_text("cant_pick_anymore", None, player.get("lang")))
			else:
				es.tell(userid, "#green", messages_text("not_your_turn", None, player.get("lang")))
		elif loserid == userid:
			if pick == 0:
				if int(es.ServerVar("sm_cap_loser_number")) > 0:
					send_pick_menu(loserid)
				else:
					es.tell(userid, "#green", messages_text("cant_pick_anymore", None, player.get("lang")))
			else:
				es.tell(userid, "#green", messages_text("not_your_turn", None, player.get("lang")))
		else:
			es.tell(userid, "#green", messages_text("not_cap", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("not_allowed", None, player.get("lang")))

def cmd_position():
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		args = es.getargs()
		if args == "gk":
			if player.steamid not in gks:
				gks.append(player.steamid)
				es.tell(userid, "#green", "Position set.")
			else:
				es.tell(userid, "#green", "You already set this position.")

		elif args == "def":
			if player.steamid not in defs:
				defs.append(player.steamid)
				es.tell(userid, "#green", "Position set.")
			else:
				es.tell(userid, "#green", "You already set this position.")

		elif args == "mid":
			if player.steamid not in mids:
				mids.append(player.steamid)
				es.tell(userid, "#green", "Position set.")
			else:
				es.tell(userid, "#green", "You already set this position.")

		elif args == "wing":
			if player.steamid not in wings:
				wings.append(player.steamid)
				es.tell(userid, "#green", "Position set.")
			else:
				es.tell(userid, "#green", "You already set this position.")

		elif args == "clear":
			if player.steamid in gks:
				gks.remove(player.steamid)

			if player.steamid in defs:
				defs.remove(player.steamid)

			if player.steamid in mids:
				mids.remove(player.steamid)

			if player.steamid in wings:
				wings.remove(player.steamid)

			es.tell(userid, "#green", "All your positions are cleared.")

		else:
			es.tell(userid, "#green", "Use one of the following parameters to set your position: gk, def, mid or wing or clear to clear your positions.")
	else:
		es.tell(userid, "#green", messages_common("not_allowed", None, player.get("lang")))

# ******************** Popup choice ********************
def popup_choice(userid, choice, name):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.ServerVar("sm_match_started") == 0:
		if es.ServerVar("sm_cap_fight_started") == 0:
			tokens["name"] = player.name

			if choice == 1:
				for ply in playerlib.getPlayerList("#human"):
					if ply.team > 1:
						es.server.queuecmd("es_xchangeteam %s 1" % (ply.userid))

				lang_msg.tell(messages_text, "spec", tokens)

				popuplib.send("sm_popup_admin_cap", userid)

			elif choice == 2:
				players = playerlib.getPlayerList("#spec,#human")
				if len(players) > 0:
					targetid = random.choice(players)

					if int(es.getplayercount(2)) <= int(es.getplayercount(3)):
						es.server.queuecmd("es_xchangeteam %s 2" % (targetid))
					else:
						es.server.queuecmd("es_xchangeteam %s 3" % (targetid))

					tokens["target"] = es.getplayername(targetid)
					lang_msg.tell(messages_text, "random_player", tokens)

				else:
					es.tell(userid, "#green", messages_text("no_player_available", None, player.get("lang")))

				popuplib.send("sm_popup_admin_cap", userid)

			elif choice == 3:
				if es.ServerVar("sm_cap_round_ended") == 0:
					es.set("sm_cap_fight_started", 1)
					es.set("sm_cap_fight_frozen", 1)

					for ply in playerlib.getPlayerList("#alive"):
						ply.freeze(1)

					lang_msg.centertell(messages_text, "prepare_fight")
					lang_msg.hudhint(messages_text, "get_ready")

					gamethread.delayedname(1, "sm_cap_fight", lang_msg.centertell, (messages_text, "prepare_fight"))
					gamethread.delayedname(2, "sm_cap_fight", lang_msg.centertell_msg, ("| 3 |"))
					gamethread.delayedname(3, "sm_cap_fight", lang_msg.centertell_msg, ("| 2 |"))
					gamethread.delayedname(4, "sm_cap_fight", lang_msg.centertell_msg, ("| 1 |"))
					gamethread.delayedname(5, "sm_cap_fight", lang_msg.centertell, (messages_text, "fight"))

					gamethread.delayedname(5, "sm_cap_fight", fight)

					lang_msg.tell(messages_text, "fight_started", tokens)
				else:
					es.tell(userid, "#green", messages_common("no_option_round_ended", None, player.get("lang")))

				popuplib.send("sm_popup_admin_cap", userid)

			elif choice == 4:
				popup_name = "sm_popup_%s" % (userid)
				if popuplib.exists(popup_name):
					popuplib.delete(popup_name)

				myPopup = popuplib.easymenu(popup_name, None, set_weapon)
				myPopup.settitle("Select a weapon for a cap fight")

				weapons = [
					"ak47", "aug", "awp", "deagle", "elite", "fiveseven", "flashbang", "g3sg1", "galil", "glock", "hegrenade", "knife",
					"m249", "m3", "m4a1", "mac10", "mp5navy", "p90", "p228", "scout", "sg550", "sg552", "smokegrenade", "tmp", "ump45", "xm1014"
				]
				for item in weapons:
					myPopup.addoption(item, item)

				myPopup.submenu(10, "sm_popup_admin_cap")

				popuplib.send(popup_name, userid)

			elif choice == 5:
				es.keycreate("sm_keygroup_set", player.steamid)
				es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "cap_fight_health")

				tokens["min"] = 1
				tokens["max"] = 250
				es.tell(userid, "#green", messages_text("type_health", tokens, player.get("lang")))

			elif choice == 6:
				es.keycreate("sm_keygroup_set", player.steamid)
				es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "cap_fight_speed")

				tokens["min"] = 0.1
				tokens["max"] = 10
				es.tell(userid, "#green", messages_text("type_speed", tokens, player.get("lang")))

			elif choice == 7:
				es.keycreate("sm_keygroup_set", player.steamid)
				es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "cap_fight_jump")

				tokens["min"] = 0
				tokens["max"] = 250
				es.tell(userid, "#green", messages_text("type_jump", tokens, player.get("lang")))

		else:
			es.tell(userid, "#green", messages_common("no_option_cap", None, player.get("lang")))
			popuplib.send("sm_popup_admin_cap", userid)
	else:
		es.tell(userid, "#green", messages_common("no_option_match", None, player.get("lang")))
		popuplib.send("sm_popup_admin_cap", userid)

# ******************** Easymenu choice ********************
def set_weapon(userid, choice, name):
	popup_name = "sm_popup_%s" % (userid)
	if popuplib.exists(popup_name):
		popuplib.delete(popup_name)

	es.set("sm_cap_fight_weapon", choice)

	popuplib.find("sm_popup_admin_cap").modline(6, "->4. %s: %s" % (popup_text("weapon"), choice))

	player = playerlib.getPlayer(userid)

	tokens = {}
	tokens["value"] = choice
	tokens["name"] = player.name
	lang_msg.tell(messages_text, "set_weapon", tokens)

	popuplib.send("sm_popup_admin_cap", userid)

def pick(userid, choice, name):
	player = playerlib.getPlayer(userid)

	if player.team > 1:
		if es.exists("userid", choice) == 1:
			popup_name = "sm_popup_%s" % (userid)
			if popuplib.exists(popup_name):
				popuplib.delete(popup_name)

			es.server.queuecmd("es_xchangeteam %s %s" % (choice, player.team))

			tokens = {}
			tokens["name"] = player.name
			tokens["target"] = es.getplayername(choice)
			lang_msg.tell(messages_text, "pick", tokens)

			winner_number = es.ServerVar("sm_cap_winner_number")
			loser_number = es.ServerVar("sm_cap_loser_number")

			if winner_number > 0 and loser_number > 0:
				if es.ServerVar("sm_cap_winner_pick") == 1:
					userid = es.ServerVar("sm_cap_loser_userid")

					es.set("sm_cap_winner_pick", 0)

					winner_number -= 1
					es.set("sm_cap_winner_number", winner_number)
				else:
					userid = es.ServerVar("sm_cap_winner_userid")

					es.set("sm_cap_winner_pick", 1)

					loser_number -= 1
					es.set("sm_cap_loser_number", loser_number)

				gamethread.delayed(0.1, send_pick_menu, (userid))
		else:
			es.tell(userid, "#green", messages_common("no_player_found", None, player.get("lang")))

			send_pick_menu(userid)
	else:
		es.tell(userid, "#green", messages_common("no_option_dead", None, player.get("lang")))

# ******************** Say filter ********************
def filter(userid, text, teamonly):
	if es.ServerVar("soccer_mod_allowed") == 1:
		player = playerlib.getPlayer(userid)
		if es.exists("key", "sm_keygroup_set", player.steamid) == 1:
			type = es.keygetvalue("sm_keygroup_set", player.steamid, "setting_type")
			text = text.strip('"')
			if type == "cap_fight_health":
				set_value(player, text, "health", 5, 0, 1, 250)
				return (0, None, 0)
			elif type == "cap_fight_speed":
				set_value(player, text, "speed", 6, 2, 0.1, 10)
				return (0, None, 0)
			elif type == "cap_fight_jump":
				set_value(player, text, "jump", 7, 0, 0, 250)
				return (0, None, 0)
			else:
				return (userid, text, teamonly)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def load_variables():
	es.set("sm_cap_fight_started", 0)
	es.set("sm_cap_fight_frozen", 0)

def fight():
	es.set("sm_cap_fight_frozen", 0)

	for player in playerlib.getPlayerList("#alive"):
		player.godmode(0)
		player.freeze(0)
		player.setHealth(es.ServerVar("sm_cap_fight_health"))
		player.setSpeed(es.ServerVar("sm_cap_fight_speed"))

		weapon = es.ServerVar("sm_cap_fight_weapon")
		if weapon != "knife":
			es.server.queuecmd("es_xgive %s weapon_%s" % (player.userid, weapon))

def set_value(player, text, type, number, decimals, min, max):
	if text != "!cancel":
		tokens = {}
		tokens["min"] = min
		tokens["max"] = max
		error = messages_text("type_%s" % (type), tokens, player.get("lang"))

		try:
			if decimals == 0:
				value = int(round(float(text), 0))
			else:
				value = round(float(text), decimals)

			if value >= min:
				if value <= max:
					es.set("sm_cap_fight_%s" % (type), value)

					popuplib.find("sm_popup_admin_cap").modline((number + 2), "->%s. %s: %s" % (number, popup_text(type), value))

					tokens["name"] = player.name
					tokens["value"] = value

					lang_msg.tell(messages_text, "set_%s" % (type), tokens)

					es.keydelete("sm_keygroup_set", player.steamid)
					popuplib.send("sm_popup_admin_cap", player.userid)
				else:
					es.tell(player.userid, "#green", error)
			else:
				es.tell(player.userid, "#green", error)
		except ValueError:
			es.tell(player.userid, "#green", error)
	else:
		es.keydelete("sm_keygroup_set", player.steamid)
		popuplib.send("sm_popup_admin_cap", player.userid)

def send_pick_menu(userid):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	players = playerlib.getPlayerList("#human,#spec")
	if len(players) > 0:
		myPopup = popuplib.easymenu(name, None, pick)
		myPopup.settitle(popup_text("select_player"))

		for player in players:
			pos = "("
			temp = []

			if player.steamid in gks:
				temp.append("GK")
			if player.steamid in defs:
				temp.append("DF")
			if player.steamid in mids:
				temp.append("MD")
			if player.steamid in wings:
				temp.append("WG")

			if len(temp) < 1:
				pos += "None"
			else:
				for i in range(0, len(temp)):
					if (i + 1) < len(temp):
						pos += "%s, " % (temp[i])
					else:
						pos += "%s" % (temp[i])

			pos += ")"

			myPopup.addoption(player.userid, "%s %s" % (player.name, pos))

		popuplib.send(name, userid)

# ******************** Unload ********************
def unload():
	gamethread.cancelDelayed("sm_cap_fight")

	es.addons.unregisterSayFilter(filter)

	popuplib.delete("sm_popup_admin_cap")